function [dt,Units] = getDurationandUnits(Ts)
% This function returns the sampling interval and a format string
% for plotting the wavelet coherence in time and frequency.
% The Units string is only for plotting.

tsformat = Ts.Format;
% Use first character of format string to determine correct
% duration object method.
tsformat = tsformat(1);
% Using the same time units as engunits. Units in engunits are
% not localized.
% time_units = {'secs','mins','hrs','days','years'};
switch tsformat
    case 's'
        dt = seconds(Ts);
        Units = 'secs';
    case 'm'
        dt = minutes(Ts);
        Units = 'mins';
    case 'h'
        dt = hours(Ts);
        Units = 'hrs';
    case 'd'
        dt = days(Ts);
        Units = 'days';
    case 'y'
        dt = years(Ts);
        Units = 'years';
end