function frequnits = wgetfrequnitstrs(menuflag)
%WGETFREQUNITSTRS Return a cell array of frequency units strings.
%
%   STRS = WGETFREQUNITS returns a cell array of standard frequency units 
%   strings.

%   STRS = WGETFREQUNITS(MENUFLAG) returns a cell array of frequency units
%   with the "Normalized Frequency" string for use in a uimenu.

%   Author(s): P. Costa
%   Copyright 1988-2002 The MathWorks, Inc.

frequnits = {[getString(message('Wavelet:getfrequnitstrs:NormalizedFrequency')) '  (cycles/sample)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (Hz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (kHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (MHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (GHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (THz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (PHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (EHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (ZHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (YHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (yHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (zHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (aHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (fHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (pHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (nHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (\muHz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (' char(956) 'Hz)'],...
            [getString(message('Wavelet:getfrequnitstrs:Frequency')) ' (mHz)']};

% Return the proper version of the Normalized Frequency string
% for the X-axis label or menu item.
if nargin == 1,
    frequnits{1} = getString(message('Wavelet:getfrequnitstrs:NormalizedFrequency'));
end

% [EOF]
