% modified from EEGlab function-pop_importdata() - import data from a Matlab variable or disk file by calling
%                    importdata().


function [EEG_EROOUT, ALLEEG_EROOUT] = f_importdata(EEG_EROIN,ALLEEG_EROIN);

EEG_EROIN = f_eeg_ero_emptyset(EEG_EROIN);
% popup window parameters
% -----------------------
geometry    = { [1.4 2.3 0.5] [1.4 2.3 0.5] [1] [2 1 2 1] [2 1 2 1] [2 1 2 1] [2 1 2 1]};
editcomments = [ 'tmp = pop_comments(get(gcbf, ''userdata''), ''Edit comments of current dataset'');' ...
    'if ~isempty(tmp), set(gcf, ''userdata'', tmp); end; clear tmp;' ];
commandload = [ '[filename, filepath] = uigetfile(''*'', ''Select a text file'');' ...
    'if filename(1) ~=0,' ...
    '   set(findobj(''parent'', gcbf, ''tag'', tagtest), ''string'', [ filepath filename ]);' ...
    'end;' ...
    'clear filename filepath tagtest;' ];
commandsetfiletype = [ 'filename = get( findobj(''parent'', gcbf, ''tag'', ''globfile''), ''string'');' ...
    'tmpext = findstr(filename,''.'');' ...
    'if ~isempty(tmpext),' ...
    '  tmpext = lower(filename(tmpext(end)+1:end));' ...
    '  switch tmpext, ' ...
    '    case ''mat'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',5);' ...
    '    case ''fdt'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',3);' ...
    '    case ''txt'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',2);' ...
    '  end;' ...
    'end; clear tmpext filename;' ];

commandload1 = [ '[filename, filepath] = uigetfile(''*'', ''Select a text file'');' ...
    'if filename(1) ~=0,' ...
    '   set(findobj(''parent'', gcbf, ''tag'', tagtest), ''string'', [ filepath filename ]);' ...
    'end;' ...
    'clear filename filepath tagtest;' ];
commandsetfiletype1 = [ 'filename = get( findobj(''parent'', gcbf, ''tag'', ''globfile''), ''string'');' ...
    'tmpext = findstr(filename,''.'');' ...
    'if ~isempty(tmpext),' ...
    '  tmpext = lower(filename(tmpext(end)+1:end));' ...
    '  switch tmpext, ' ...
    '    case ''mat'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',5);' ...
    '    case ''fdt'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',3);' ...
    '    case ''txt'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',2);' ...
    '  end;' ...
    'end; clear tmpext filename;' ];




commandselica = [ 'res = inputdlg2({ ''Enter dataset number'' }, ''Select ICA weights and sphere from other dataset'', 1, { ''1'' });' ...
    'if ~isempty(res),' ...
    '   set(findobj( ''parent'', gcbf, ''tag'', ''weightfile''), ''string'', sprintf(''ALLEEG(%s).icaweights'', res{1}));' ...
    '   set(findobj( ''parent'', gcbf, ''tag'', ''sphfile'')   , ''string'', sprintf(''ALLEEG(%s).icasphere'' , res{1}));' ...
    'end;' ];
commandselchan = [ 'res = inputdlg2({ ''Enter dataset number'' }, ''Select channel information from other dataset'', 1, { ''1'' });' ...
    'if ~isempty(res),' ...
    '   set(findobj( ''parent'', gcbf, ''tag'', ''chanfile''), ' ...
    '                ''string'', sprintf(''{ ALLEEG(%s).chanlocs ALLEEG(%s).chaninfo ALLEEG(%s).urchanlocs }'', res{1}, res{1}, res{1}));' ...
    'end;' ];

uilist = { ...
    { 'Style', 'text', 'string', 'Fourth-order tensor (.mat)', 'horizontalalignment', 'right', 'fontweight', 'bold' }, ...
    { 'Style', 'edit', 'string', '', 'horizontalalignment', 'left', 'tag',  'globfile' }, ...
    { 'Style', 'pushbutton', 'string', 'Browse', 'callback', ...
    [ 'tagtest = ''globfile'';' commandload commandsetfiletype ] },...
    ...
    { 'Style', 'text', 'string', 'Channel location file (.mat)', 'horizontalalignment', 'right' , 'fontweight', 'bold' },  ...
    { 'Style', 'edit', 'string', '', 'horizontalalignment', 'left', 'tag',  'sphfile' }, ...
    { 'Style', 'pushbutton', 'string', 'Browse', 'callback', [ 'tagtest = ''sphfile'';' commandload ] },{}...
    ...
    { 'Style', 'text', 'string', 'Data sampling rate (Hz)', 'horizontalalignment', 'right', ...
    }, { 'Style', 'edit', 'string', '0' }, ...
    { 'Style', 'text', 'string', 'Levels of first-factor (within-subject)', 'horizontalalignment', 'right', ...
    },   { 'Style', 'edit', 'string', '0' }, ...
    ...
    { 'Style', 'text', 'string', 'Epoch Start (ms)', 'horizontalalignment', 'right', ...
    },  { 'Style', 'edit', 'string', '0' }, ...
    { 'Style', 'text', 'string', 'Levels of second-factor (within-subject)', 'horizontalalignment', 'right', ...
    },   { 'Style', 'edit', 'string', '0' }, ...
    { 'Style', 'text', 'string', 'Epoch End (ms)', 'horizontalalignment', 'right', ...
    }, { 'Style', 'edit', 'string', '0' }, ...
    { 'Style', 'text', 'string', 'Levels of third-factor (within-subject)', 'horizontalalignment', 'right', ...
    },   { 'Style', 'edit', 'string', '0' }, ...
    { 'Style', 'text', 'string', 'Levels of between-subject factors', 'horizontalalignment', 'right', ...
    },   { 'Style', 'edit', 'string', '1' }, ...
    {},   {}};



[ results newcomments ] = inputgui( geometry, uilist, 'functionhelp(''f_importdata'');', 'Import dataset info -- f_importdata()');


if isempty(results)
    EEG_EROOUT = EEG_EROIN;
    ALLEEG_EROOUT = ALLEEG_EROIN;
    return;
end


results1 = results([1:3,5,7]);



count1 = 0;
for ii = 1:length(results1)
    if isempty(results1{ii}) == 1
        count1 = count1 +1;
    end
end

if count1 ~= 0
    errordlg2('Please input the necessary parameters');
    EEG_EROOUT = EEG_EROIN;
    ALLEEG_EROOUT = ALLEEG_EROIN;
    return;
else
    
    EEG_EROIN.data  = importdata(results{1});
    EEG_EROIN.chanlocs  = importdata(results{2});
    EEG_EROIN.srate = str2num(results{3});
    EEG_EROIN.epochStart = str2num(results{5});
    EEG_EROIN.epochEnd = str2num(results{7});
    subNum = size(EEG_EROIN.data,4);
    factor1= str2num(results{4});
    factor2= str2num(results{6});
    factor3= str2num(results{8});
    groupNum = str2num(results{9});
    
    if groupNum < 2
        
        if factor1 < 2
            errordlg2('The levels for the 1st factor should be more than 1');
            EEG_EROOUT = EEG_EROIN;
            ALLEEG_EROOUT = ALLEEG_EROIN;
            return;
        end
        
          
        if (factor1 == 0 & factor2 ~= 0)| (factor1 == 0 & factor3 ~= 0)
            errordlg2('The levels for the 1st factor should be more than 1');
            EEG_EROOUT = EEG_EROIN;
            ALLEEG_EROOUT = ALLEEG_EROIN;
            return;
        end
        
        
        
        
        Sti_Name = f_form_stiname_withsub(factor1,factor2,factor3);
        GroupIdex = ones(subNum,1);
        if size(EEG_EROIN.data,3) ~= length(Sti_Name)
            errordlg2('Please input correct parameters');
            EEG_EROIN = f_eeg_ero_emptyset(EEG_EROIN);
            EEG_EROOUT = EEG_EROIN;
            ALLEEG_EROOUT = ALLEEG_EROIN;
            return;
        end
        
    else
        [GroupIdex,Sti_Name,Sti_Name_within] = f_form_stiname_betwsub(groupNum,factor1,factor2,factor3);
    EEG_EROIN.Sti_Name_within = Sti_Name_within;
    end
    
    
    EEG_EROIN.Sti_Name = Sti_Name;
    EEG_EROIN.GroupIdex = GroupIdex;
    EEG_EROIN.betwSub_level = groupNum;
    EEG_EROIN.withSub_level_one = factor1;
    EEG_EROIN.withSub_level_two = factor2;
    EEG_EROIN.withSub_level_three = factor3;
    
    
    if length(EEG_EROIN.chanlocs) ~= size(EEG_EROIN.data,1) | length(EEG_EROIN.GroupIdex)~= size(EEG_EROIN.data,4)
        errordlg2('Please input correct parameters');
        EEG_EROIN = f_eeg_ero_emptyset(EEG_EROIN);
        EEG_EROOUT = EEG_EROIN;
        ALLEEG_EROOUT = ALLEEG_EROIN;
        return;
    end
    
    EEG_EROOUT = EEG_EROIN;
    ALLEEG_EROOUT = f_eeg_store(ALLEEG_EROIN,EEG_EROOUT);
    disp('The signal has been imported.');
end;
return;
