% modified from EEGlab function-pop_importdata() - import data from a Matlab variable or disk file by calling
%                    importdata().


function [EEG_EROOUT, ALLEEG_EROOUT] = f_importprocesseddata(EEG_EROINPUT,ALLEEG_EROINPUT);

% if several arguments, assign values
% popup window parameters
% -----------------------
geometry    = {[2 1 0.5]};
editcomments = [ 'tmp = pop_comments(get(gcbf, ''userdata''), ''Edit comments of current dataset'');' ...
    'if ~isempty(tmp), set(gcf, ''userdata'', tmp); end; clear tmp;' ];
commandload = [ '[filename, filepath] = uigetfile(''*.mat'', ''Select a data file'');' ...
    'if filename(1) ~=0,' ...
    '   set(findobj(''parent'', gcbf, ''tag'', tagtest), ''string'', [ filepath filename ]);' ...
    'end;' ...
    'clear filename filepath tagtest;' ];
commandsetfiletype = [ 'filename = get( findobj(''parent'', gcbf, ''tag'', ''globfile''), ''string'');' ...
    'tmpext = findstr(filename,''.'');' ...
    'if ~isempty(tmpext),' ...
    '  tmpext = lower(filename(tmpext(end)+1:end));' ...
    '  switch tmpext, ' ...
    '    case ''mat'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',5);' ...
    '    case ''fdt'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',3);' ...
    '    case ''txt'', set(findobj(gcbf,''tag'', ''loclist''), ''value'',2);' ...
    '  end;' ...
    'end; clear tmpext filename;' ];
%
uilist = { ...
    { 'Style', 'text', 'string', 'The processed data by this Toolbox (.mat)', 'horizontalalignment', 'right', 'fontweight', 'bold' }, ...
    { 'Style', 'edit', 'string', '', 'horizontalalignment', 'left', 'tag',  'globfile' }, ...
    { 'Style', 'pushbutton', 'string', 'Browse', 'callback', ...
    [ 'tagtest = ''globfile'';' commandload commandsetfiletype ] } };

[ results newcomments ] = inputgui( geometry, uilist, 'functionhelp(''f_importprocesseddata'');', 'Import dataset info -- f_importprocesseddata()');


if isempty(results)
    EEG_EROOUT = EEG_EROINPUT;
    ALLEEG_EROOUT = ALLEEG_EROINPUT ;
else
    EEG_EROOUT = importdata(results{1});
    ALLEEG_EROOUT = f_eeg_store(ALLEEG_EROINPUT,EEG_EROOUT);
    disp('The processed signal has been imported.');
end;

return;
