function f_between_subject_three_factor_anovan(EEG_ERO);


if isempty(EEG_ERO) | isempty(EEG_ERO.data)
    errordlg2('Cannot further analysis an empty data');
    return;
end



if EEG_ERO.betwSub_level < 2
    errordlg2('>Statistical Analysis>Winin-subject rm-ANOVA');
    return;
end

groupNum=EEG_ERO.betwSub_level ;
factor1=EEG_ERO.withSub_level_one;
factor2=EEG_ERO.withSub_level_two ;
factor3=EEG_ERO.withSub_level_three;
Group_Idx = EEG_ERO.GroupIdex;


if factor2 < 1 & factor1 > 1
    errordlg2('>Between-subject ANOVA>Two-factor rm-ANOVA');
    return;
      
end

if factor2 < 1 & factor1 <= 1
    errordlg2('Cannot be analyzed in this toolbox');
    return;
      
end


data = double(EEG_ERO.data);
topo_box = data';
[NumSubs,stiNum]= size(topo_box);

X = reshape(topo_box,1,[]);

if groupNum > 1 & factor1 > 1 & factor2>0 & factor3 ==0
    
        count = 0;
        count1 = 0;
        for Numoflevel_second = 1:factor1
            idxStart = NumSubs*factor2*(Numoflevel_second-1) + 1;
            idxEnd = NumSubs*factor2*(Numoflevel_second);
            staIDX(idxStart:idxEnd,3) = Numoflevel_second;
            for Numoflevel_third = 1:factor2
                count = count + 1;
                idxStart1 = NumSubs*(count-1) + 1;
                idxEnd1 = NumSubs*(count);
                staIDX(idxStart1:idxEnd1,2) = Numoflevel_third;
                count1  = count1 +1;
                idxStart2 = NumSubs*(count1-1) + 1;
                idxEnd2 = NumSubs*(count1);
                staIDX(idxStart2:idxEnd2,1) = Group_Idx;
            end
        end
        varnames(3) = cellstr({'Group'});
        varnames(1) = cellstr({'A'});
        varnames(2) = cellstr({'B'});
        disp('>>The n-way ANOVA results for  three-factorof between-subject analysis:');
        fprintf('\n');
        [~,atab] = anovan(X,staIDX,'model',3 ,'varnames',strvcat('A', 'B', 'Group'))
else
    
    
    errordlg2('Please check data');
    return;
    
end
return;