function f_between_subject_two_factor_rmanova(EEG_ERO);

if isempty(EEG_ERO) | isempty(EEG_ERO.data)
    errordlg2('Cannot further analysis an empty data');
    return;
end



if EEG_ERO.betwSub_level < 2
    errordlg2('>Statistical Analysis>Winin-subject rm-ANOVA');
    return;
end

if EEG_ERO.sta_index==0
    errordlg2('Please select a time window or a region');
    return;
end

if EEG_ERO.withSub_level_two > 0
    errordlg2('Between-subject rm-ANOVA>Three-factor n-way ANOVA');
    return;
end

groupNum=EEG_ERO.betwSub_level ;
factor1=EEG_ERO.withSub_level_one;
factor2=EEG_ERO.withSub_level_two ;
% factor3=EEG_ERO.withSub_level_three;
Group_Idx = EEG_ERO.GroupIdex;

data = double(EEG_ERO.data);
topo_box = data';

if groupNum > 1 & factor1 > 1 & factor2 == 0
    
    [subNum,stiNum]= size(topo_box);
    BTFacs =[];
    WInFacs = [];
    S = [];
    Y = [];
    for is = 1:groupNum
        idx1 = find(Group_Idx == is);
        X1 = topo_box(idx1,:);
        X1  = reshape(X1,[],1);
        Y = [Y;X1];
        clear X1;
        for iss  = 1:stiNum
            
            BTFacs = [BTFacs;ones(length(idx1),1)*is];
            %%
            WInFacs = [WInFacs; ones(length(idx1),1)*iss];
            %%
            S =[S;idx1];
        end
        clear idx1;
    end
    D_a(:,1)= Y;
    D_a(:,2)= BTFacs;
    D_a(:,3)= WInFacs;
    D_a(:,4)= S;
    factorNames={'Group','Factor'};
    disp('>>The repated meansurement ANOVA results for two-factor of between-subject analysis:');
    [SSQs, DFs, MSQs, Fs, Ps] = f_mixed_between_within_anova1(D_a,factorNames);
    % three-way ANOVA
    
end

return;